// ============================================================================
//  $Id$
//  $Name$
// ============================================================================
#ifndef __TEVENT_HH
#define __TEVENT_HH

#include "TGlobals.hh"
#include "TDataRecord.hh"

class TDataRecord;

class TEvent
{

  private:
    Tint theEventID;
    TDataRecord theDataRecord;

  public:
    TEvent( Tint eventID, const TDataRecord& eventData );
    TEvent( const TEvent& right );
    ~TEvent();

  public:
    const TEvent& operator=( const TEvent& right );
    Tbool operator==( const TEvent& right ) const;
    Tbool operator!=( const TEvent& right ) const;

  public:
    Tint GetEventID() const;
    const TDataRecord& GetDataRecord() const;
    Tvoid SetEventID( Tint eventID );
    Tvoid SetDataRecord( const TDataRecord& record );

  public:
    Tvoid Clear();

};

inline Tint TEvent::GetEventID() const
{
  return( theEventID );
}

inline const TDataRecord& TEvent::GetDataRecord() const
{
  return( theDataRecord );
}

inline Tvoid TEvent::SetEventID( Tint eventID )
{
  theEventID = eventID;
  return;
}

inline Tvoid TEvent::SetDataRecord( const TDataRecord& record )
{
  theDataRecord = record;
  return;
}

#endif
