// ============================================================================
//  $Id: TReadoutElement.cc,v 1.1.1.1 2002/12/04 23:47:39 iwai Exp $
//  $Name:  $
// ============================================================================
#include "TReadoutElement.hh"
#include "TDataElement.hh"
#include "TModule.hh"

TReadoutElement::TReadoutElement( TModule* module, const Tstring& id )
  : TReadoutDefinition( id ), theModule( module )
{;}

TReadoutElement::TReadoutElement( const TReadoutElement& right )
  : TReadoutDefinition( right ), theModule( right.theModule )
{;}

TReadoutElement::~TReadoutElement()
{;}

TDataElement TReadoutElement::ReadData()
{
  TDataElement element( tTypeUnknown, theID );
  theModule -> FillData( element );
  return( element );
}

const TReadoutElement& TReadoutElement::operator=( const TReadoutElement& right )
{
  *( (TReadoutDefinition*)this ) = *( (TReadoutDefinition*)(&right) );
  theModule = right.theModule;
  return( *this );
}

Tbool TReadoutElement::operator==( const TReadoutElement& right ) const
{
  Tbool ret = Ttrue;
  ret &= ( *( (TReadoutDefinition*)this ) == *( (TReadoutDefinition*)(&right) ) );
  ret &= ( *theModule == *(right.theModule) );
  return( ret );
}

Tbool TReadoutElement::operator!=( const TReadoutElement& right ) const
{
  Tbool ret = Tfalse;
  ret |= ( *( (TReadoutDefinition*)this ) != *( (TReadoutDefinition*)(&right) ) );
  ret |= ( *theModule != *(right.theModule) );
  return( ret );
}
