// ============================================================================
//  $Id: TReadoutSection.cc,v 1.1.1.1 2002/12/04 23:47:39 iwai Exp $
//  $Name:  $
// ============================================================================
#include "TReadoutSection.hh"
#include "TDataSection.hh"

TReadoutSection::TReadoutSection( const Tstring& id )
  : TReadoutDefinition( id ), TReadoutSegmentList()
{;}

TReadoutSection::TReadoutSection( const TReadoutSection& right )
  : TReadoutDefinition( right ), TReadoutSegmentList( right )
{;}

TReadoutSection::~TReadoutSection()
{;}

TDataSection TReadoutSection::ReadData()
{
  TDataSection section( theID );

  for ( Tsize_t i = 0; i < size(); i ++ )
    section.push_back( ( (*this)[ i ] ).ReadData() );

  return( section );
}

const TReadoutSection& TReadoutSection::operator=( const TReadoutSection& right )
{
  *( (TReadoutDefinition*)this ) = *( (TReadoutDefinition*)(&right) );
  *( (TReadoutSegmentList*)this ) = *( (TReadoutSegmentList*)(&right) );
  return( *this );
}

Tbool TReadoutSection::operator==( const TReadoutSection& right ) const
{
  Tbool ret = Ttrue;
  ret &= ( *( (TReadoutDefinition*)this ) == *( (TReadoutDefinition*)(&right) ) );
  ret &= ( *( (TReadoutSegmentList*)this ) == *( (TReadoutSegmentList*)(&right) ) );
  return( ret );
}

Tbool TReadoutSection::operator!=( const TReadoutSection& right ) const
{
  Tbool ret = Tfalse;
  ret |= ( *( (TReadoutDefinition*)this ) != *( (TReadoutDefinition*)(&right) ) );
  ret |= ( *( (TReadoutSegmentList*)this ) != *( (TReadoutSegmentList*)(&right) ) );
  return( ret );
}
