// ============================================================================
//  $Id: DummyAdcViewCommand.cc,v 1.1 2002/12/09 07:20:36 iwai Exp $
//  $Name:  $
// ============================================================================
#include "TRunManager.hh"
#include "TUserInterface.hh"
#include "TOutputObjectFile.hh"

#include "DummyAdcViewCommand.hh"
#include "DummyRunAction.hh"

static const Tstring name = "/local/adcview";
static const Tstring desc = "view histogram(ADC)";

DummyAdcViewCommand::DummyAdcViewCommand( TRunManager* manager )
  : TCommand( manager, name, desc )
{;}

DummyAdcViewCommand::~DummyAdcViewCommand()
{;}

Tvoid DummyAdcViewCommand::Execute( const TstringList& arguments )
{
  TUserInterface* ui = theRunManager -> GetUserInterface();
  DummyRunAction* action = (DummyRunAction*)( theRunManager -> GetRunAction() );
  Tstring filename = action -> GetOutputFile() -> GetFileName();
  Tstring com = "/system/shell";
  TstringList args;
  args.push_back( "./../../bin/adcview" );
  args.push_back( filename );
  args.push_back( "&" );

  ui -> ExecuteCommand( com, args );

  return;
}
