// ============================================================================
//  $Id: DummyFlashAdcViewCommand.cc,v 1.1 2002/12/09 07:20:36 iwai Exp $
//  $Name:  $
// ============================================================================
#include "TRunManager.hh"
#include "TUserInterface.hh"
#include "TOutputObjectFile.hh"

#include "DummyFlashAdcViewCommand.hh"
#include "DummyRunAction.hh"

static const Tstring name = "/local/fadcview";
static const Tstring desc = "view 2D plot(Flash ADC)";

DummyFlashAdcViewCommand::DummyFlashAdcViewCommand( TRunManager* manager )
  : TCommand( manager, name, desc )
{;}

DummyFlashAdcViewCommand::~DummyFlashAdcViewCommand()
{;}

Tvoid DummyFlashAdcViewCommand::Execute( const TstringList& arguments )
{
  TUserInterface* ui = theRunManager -> GetUserInterface();
  DummyRunAction* action = (DummyRunAction*)( theRunManager -> GetRunAction() );
  Tstring filename = action -> GetOutputFile() -> GetFileName();
  Tstring com = "/system/shell";
  TstringList args;
  args.push_back( "./../../bin/fadcview" );
  args.push_back( filename );
  args.push_back( "&" );

  ui -> ExecuteCommand( com, args );

  return;
}
