// ============================================================================
//  $Id: DummyAdcViewCommand.cc,v 1.1.1.1 2003/01/04 08:07:14 iwai Exp $
//  $Name:  $
// ============================================================================
#include "TRunManager.hh"
#include "TUserInterface.hh"
#include "TOutputObjectFile.hh"

#include "DummyAdcViewCommand.hh"
#include "DummyRunAction.hh"

static const Tstring _name = "/local/adcview";
static const Tstring _desc = "view histogram(ADC)";

DummyAdcViewCommand::DummyAdcViewCommand()
  : TCommand( _name, _desc )
{;}

DummyAdcViewCommand::~DummyAdcViewCommand()
{;}

Tvoid DummyAdcViewCommand::Execute( const TstringList& arguments )
{
  TUserInterface* ui = theRunManager -> GetUserInterface();
  DummyRunAction* action = (DummyRunAction*)( theRunManager -> GetRunAction() );
  Tstring filename = action -> GetOutputFile() -> GetFileName();
  Tstring com = "/system/shell";
  TstringList args;
  args.push_back( "./../../bin/adcview" );
  args.push_back( filename );
  args.push_back( "&" );

  ui -> ExecuteCommand( com, args );

  return;
}
