// ============================================================================
//  $Id: DummyGeant4ViewCommand.cc,v 1.1.1.1 2003/01/04 08:07:14 iwai Exp $
//  $Name:  $
// ============================================================================
#include "TRunManager.hh"
#include "TUserInterface.hh"
#include "TOutputObjectFile.hh"

#include "DummyGeant4ViewCommand.hh"
#include "DummyRunAction.hh"

static const Tstring _name = "/local/geant4view";
static const Tstring _desc = "view histogram(Geant4)";

DummyGeant4ViewCommand::DummyGeant4ViewCommand()
  : TCommand( _name, _desc )
{;}

DummyGeant4ViewCommand::~DummyGeant4ViewCommand()
{;}

Tvoid DummyGeant4ViewCommand::Execute( const TstringList& arguments )
{
  TUserInterface* ui = theRunManager -> GetUserInterface();
  DummyRunAction* action = (DummyRunAction*)( theRunManager -> GetRunAction() );
  Tstring filename = action -> GetOutputFile() -> GetFileName();
  Tstring com = "/system/shell";
  TstringList args;
  args.push_back( "./../../bin/geant4view" );
  args.push_back( filename );
  args.push_back( "&" );

  ui -> ExecuteCommand( com, args );

  return;
}
